;Charge Beam Mod by person701
;This code causes Samus to fire charge shots in place of uncharged shots if Charge Beam is equiped
;It is still possible to charge shots and as such, I've included Black Falcon's tractor beam to give it a bit more function. Credit to him on that.
lorom

org $90B8D0		;hi-jack
	JMP $F640	;free space

org $90F640		;new code here
	LDA $09A7
	BIT #$0010	;normally, charge won't be equiped unless you have it
	BNE Charge	;if charge is equiped, go there
	LDA $09A6	;write what we overwrote to jump here
	JMP $B8D3	;back to original code
Charge:
	LDA $09A6	;write what we overwrote to jump here
	ORA #$8010	;always fire charge shots :D
	JMP $B8D6


;---Tractor beam code courtesy of Black Falcon---
;------------------------------------------------
org $90B860		;how long charge beam must be held down to fire a beam
	DB $3C		;default = $3C

org $91D756		;charge beam timer check for samus palette to change (should be equal to above value)
	DB $3C		;default = $3C
	
org $86F057		;hijack point
	JSR CHECKCHARGE

org $86F4AB
CHECKCHARGE:
	LDA $0CD0 : BEQ GTFO		;check if charge timer > 0
HERE:
	LDA $0AF6 : CMP $1A4B,x : BEQ NEXT : BMI UP : BPL DOWN : BRA GTFO	;check item pickup's X position relative to samus
NEXT:
	LDA $0AFA : CMP $1A93,x : BEQ GTFO : BPL LEFT : BMI RIGHT			;check item pickup's Y position relative to samus
UP:
	DEC $1A4B,x : BRA NEXT		;go up
DOWN:
	INC $1A4B,x : BRA NEXT		;go down
LEFT:
	INC $1A93,x : BRA GTFO		;go left
RIGHT:
	DEC $1A93,x					;go right
GTFO:
	LDA $0AF6 : RTS				;go out